subroutine newweak_test

    '##Initial the two residual lists
    %residlist =""
    !thisreg = 0 
    
    '###the list in the for loop must correspond to Ylist (must be hardwired)
    for %var lshare relpm_h
	!thisreg = !thisreg+1
	'## regress all regressors on instruments
	equation weak.ls {%var}  {%Zlist}  {%Xlist}
	weak.makeresid {%var}_r
	%residlist = %residlist + %var +"_r "  
    next
    !nobs = @regobs    
 
    group weakresid {%residlist}
    matrix mzbary = weakresid
    group reg_group {%Ylist} 
    matrix reg = reg_group

    
    matrix sigmavv = @transpose(reg)*mzbary/(!nobs-!nx-!nz)

    group xreg_group {%Xlist}
    matrix xreg = xreg_group
    group z_group  {%Zlist}
    matrix z = z_group
    
    vector(!nobs) ones = 1
    matrix mx = @makediagonal(ones)-xreg*@inverse(@transpose(xreg)*xreg)*@transpose(xreg)
    matrix pzperp= mx*z*@inverse(@transpose(z)*mx*z)*@transpose(z)*@transpose(mx) 
    

    '##Create square root of inverse of sigmavv
    sym sigmavvinv = @inverse(sigmavv)
    matrix eigvec = @eigenvectors(sigmavvinv)
    vector eigval = @eigenvalues(sigmavvinv) 
    matrix sigmanhalf = eigvec * @makediagonal(sqr(eigval)) * @transpose(eigvec)
    matrix yperp = mx*reg
    
    sym galt =sigmanhalf*@transpose(yperp)*pzperp*yperp*@transpose(sigmanhalf)/!nz
    vector {%eq}_geig = @eigenvalues(galt) 
    '## clean up
    delete reg_group xreg_group reg sigmavv sigmavvinv eigvec eigval sigmanhalf yperp galt z_group z
endsub

