subroutine loaddata


'###################Read in Data###################
' All data was downloaded from the original sources in the second quarter of 2007.
' Additional spreadsheets in the data directory show the original downloads

'manipulations are performed in loadreviseddata.m

smpl 1947:1 2006:4
'### DATA manipulations are performed in xls2matlab.m
'###
'### Read indexes (1992 = 100) for, in this order:
'### 1. Hours				hours
'### 2. Compensation			totw	
'### 3. Non-Labor Payments		nlpay
'### 4. Hourly Compensation		hpay
'### 5. Unit Labor Costs			ulc
'### 6. Labor Share			share
'### 7. Unit Labor Payments		unlp
'### 8. Implicit Price Deflator		paydefl
'### 9. Real Hourly Compensation	rhpay
'### 10. Output				y
'### 11. Current Dollar Output		yn
read Data\BLSnonfarmbusiness.txt hours totw nlpay hpay ulc share unlp paydefl rhpay y yn

'### GDP goods prices
smpl 1947:1 2007:1
read Data\pgdp_gd2.txt pgdp_gd

'### nominal value of traded goods output
read Data\gdpv_gd.txt gdpv_gd  

'########Price of Exported Goods and Value of Exported Goods from BEA Table 4.2.4
smpl 1967:1 2006:4
read Data\pxg.txt pxg xgv

'########Price and nominal volume of non-oil imports excluding oil products
smpl 1967:1 2006:4
read Data\pmnfl.txt pmg
read Data\mnflv.txt mgv

endsub

